#ifndef MEM_ARENA_H
#define MEM_ARENA_H

#include "aliases.h"
#include <stdbool.h>

#ifdef __cplusplus
extern "C" {
#endif // __cplusplus

typedef struct growing_arena Arena;

bool wapp_mem_arena_init(Arena **arena, u64 base_capacity);
void *wapp_mem_arena_alloc(Arena *arena, u64 size);
void *wapp_mem_arena_alloc_aligned(Arena *arena, u64 size, u64 alignment);
void wapp_mem_arena_clear(Arena *arena);
void wapp_mem_arena_destroy(Arena **arena);

#ifdef __cplusplus
}
#endif // __cplusplus

#endif // !MEM_ARENA_H
